fit.Q.ps <- function(ps, family.YAW, data, name.A, script.A, name.Y, mod="add"){

  ## use linear predictor
  data$ps <- log(ps/(1-ps))
  
  if (mod == "add"){

    Q.form <- as.formula(paste(name.Y, "~", name.A, "+ s(ps)"))
    Q.fit <- gam(Q.form, family=family.YAW, data=data)

    da <- data
    Qn.mat <- matrix(0, nrow=nrow(data), ncol=length(script.A))
    for (j in 1:ncol(Qn.mat)){
      da[,name.A] <- script.A[j]
      Qn.mat[,j] <- predict(Q.fit, newdata=da, type="response")
    }

  }else if (mod == "strat"){
    
    Q.form <- as.formula(paste(name.Y, "~ s(ps)"))    
    data0 <- data[data[,name.A] == 0,]
    Q.fit0 <- gam(Q.form, family=family.YAW, data=data0)

    data1 <- data[data[,name.A] == 1,]
    Q.fit1 <- gam(Q.form, family=family.YAW, data=data1)
    
    Qn.mat <- matrix(0, nrow=nrow(data), ncol=length(script.A))
    Qn.mat[,1] <- predict(Q.fit0, newdata=data, type="response")
    Qn.mat[,2] <- predict(Q.fit1, newdata=data, type="response")

  }else{
    stop(paste("value", mod, "for parameter mod currently not supported."))
  }
  
  Qn.mat
}
