fit.msm <- function(formula.msm, formula.AW, M, data, formula.AV=NULL, family.msm="gaussian", family.AW="binomial"){

  name.A <- as.character(formula.AW)[2]
  n <- nrow(data)

  family.AV <- family.AW

  gn.AW <- fit.g(formula.AW, family.AW, data)

  if (!is.null(formula.AV)){    
    gn.AV <- fit.g(formula.AV, family.AV, data)
  }else{
    gn.AV <- matrix(1, nrow=nrow(gn.AW), ncol=ncol(gn.AW))
  }

  wt.mat <- gn.AV/gn.AW  
  
  A <- data[,name.A]
  A <- A - min(A) + 1
    
  wt <- wt.mat[cbind(1:n, A)]
  wt.M <- ifelse(wt > M, M, wt)
  data$wt <- wt.M

  if (family.msm == "binomial"){
    old <- options("warn")$warn
    options(warn=-1)
  }
  msm.fit <- glm(formula.msm, family=family.msm, weights=wt, data=data)
  if (family.msm == "binomial") options(warn=old)
  msm.fit

}
