get.phi <- function(beta, X0, Y0, frac.M, n, msm.family){
  np <- ncol(X0)
  
  m.deriv <- msm.deriv(X0, beta, family=msm.family)
  fitted <- msm.fitted(X0, beta, family=msm.family)
  resid <- Y0 - fitted
  deriv.res <- m.deriv*matrix(rep(resid, np), ncol=np)      

  ## for logistic models, weight by 1/variance  
  h.AV <- matrix(1, nrow=nrow(X0), ncol=np)  
  if (msm.family == "binomial") h.AV  <- h.AV / matrix(rep((fitted*(1-fitted)),np), ncol=np)
  
  phi <- apply((frac.M*h.AV)*deriv.res, 2, sum)/n

  phi.prime <- -t(m.deriv)%*%(m.deriv*frac.M*h.AV)/n
  phi.prime.inv <- solve(phi.prime)
  delta <- phi.prime.inv%*%phi

  
  list(phi=phi, delta=delta)
}
