msm.deriv <- function(X, beta, family="gaussian"){
  
  np <- ncol(X)
  if (np != length(beta)) stop("Length of beta must be equal to the number of columns in X.")
  
  if (family == "gaussian"){
    deriv <- X 
  }else if (family == "binomial"){
    fac <- exp(X%*%beta)/((1+exp(X%*%beta))^2)
    deriv <- X*matrix(rep(fac, np), ncol=np)
  }else{
    stop("Argument supplied for family currently not supported.")
  }
  deriv
}

