msm.fitted <- function(X, beta, family="gaussian"){
  
  np <- ncol(X)
  if (np != length(beta)) stop("Length of beta must be equal to the number of columns in X.")
  
  if (family == "gaussian"){
    fitted <- X%*%beta 
  }else if (family == "binomial"){
    fitted <- 1/(1+exp(-X%*%beta))
  }else{
    stop("Argument supplied for family currently not supported.")
  }
  fitted
}
